//**********************************************************************************************************\
//
//	files.h:	File access, etc.
//
//**********************************************************************************************************/


int   File_Append_BinaryFile	(FILE* writeHandle, const char* fileToRead);
int	  File_Append_MemoryBlock	(FILE* writeHandle, byte* data, size_t dataLength);
int   File_Append_FileBlock     (FILE* writeHandle, FILE* readHandle, int offset, int fileReadLength);

// Cursor positioning of open file
int   File_GetCursor			(FILE* fileHandle);
void  File_SetCursor			(FILE* fileHandle, int position);
void  File_SetCursor_ToStart	(FILE* fileHandle);

// These check to see if the data was read/written amd return bytes written or false.
int	  File_Safe_Read			(FILE *f, void *buffer, size_t count);
int   File_Safe_Write			(FILE *f, void *buffer, size_t count);


fbool File_Write_Binary			(const char* writeFileName, byte* data, int numBytes); // Simply write some bytes to disk creating fil

// General file functions

fbool File_Delete				(const char *path);
fbool File_Rename				(const char* currentName, const char* newName);
fbool File_Exists				(const char *path);
int   File_Size					(const char *path);
int   File_Time					(const char *path); // Returns the seconds since midnight 1970 "Unix time"

fbool File_Directory_TestWrite	(const char* path); // Found out if we can write a temp file to a directory
fbool File_Rename_With_Prefix	(const char* path, const char* prefix);


typedef struct
{
	fbool	marked;
	char	text[1024];
	char	extra[12]; // Keep 16 aligned
} text1024_t;

typedef struct
{
	char	text[16];
} text256_t;

typedef struct
{
	char	text[16];
} text16_t;

text1024_t* FolderMatch_Populate_Alloc (const char* dirString, const char* filter, int* count);
text1024_t* FileMatch_Populate_Alloc (const char* dirString, const char* filter, int* count);