//**********************************************************************************************************\
//
//	project.h:	Main project header
//
//**********************************************************************************************************/

#define MAX_PATH_IS_1024					1024

// Headers
#include <direct.h>
#include <stdlib.h>
#include <stdio.h>
#include <tchar.h>
#include <stddef.h> 
#include <string.h>
#include <math.h>
#include <time.h>
#include <io.h>

#include "environment.h"
#include "image.h"
#include "files.h"
#include "strings.h"
#include "archive_types.h"


// Mathlike stuffs?

#define SQUARED(x)	((x)*(x))
#define IS_MULTIPLE_OF_16(number) (fmod (number, 16) == 0)
#define IS_MULTIPLE_OF_32(number) (fmod (number, 32) == 0)

int Next_Highest_Multiple_Of (int someNumber, int multiple);

typedef struct				{ int x;   int y;							} ScreenXY;
typedef struct				{ ScreenXY topLeft;   ScreenXY bottomRight;	} ScreenRect;

#define SCREENRECT_OF_OVERLAP(rc1, rc2) {                                                          \
{   FLOOR(rc1.topLeft.x,     rc2.topLeft.x),       FLOOR(rc1.topLeft.y,     rc2.topLeft.y)    },   \
{ CEILING(rc1.bottomRight.x, rc2.bottomRight.x), CEILING(rc1.bottomRight.y, rc2.bottomRight.y)} }


fbool ScreenRect_DoOverlap (const ScreenRect myRect, const ScreenRect otherRect);

int System_GetCurrentWorkingDirectory (char* buffer, fbool PrintIt);

// File system





fbool Sort_Memory_Blocks_By_Name (char* memoryBlock, size_t memBlockSize, size_t blockCount, size_t stringOffset);

int File_HasDotExtension (const char *filename, const char *extension);

fbool Fatal_Error_And_Exit (const char *error, ...);



//  Homelesses ...

int RoundUp_To_Power_Of_Two (const int myInteger);
int Center_Position_BigSize_LittleSize_Int (int biglength, int littlelength);

