//**********************************************************************************************************\
//
//	sort.c:	Raw memory sorting
//
//**********************************************************************************************************/

#include "project.h"

fbool Sort_Memory_Blocks_By_Name (char* memoryBlock, size_t memBlockSize, size_t blockCount, size_t stringOffset) 
{
	fbool	anySwap = False;
	fbool	didSwap	= True;
	char*	tmpBuf = Memory_calloc (memBlockSize, 1, "Sort temp buf");
	int		limit	= blockCount - 1;
	int		i;


    while (didSwap) 
	{
        didSwap = False;

        for (i = 0; i < limit; i++)  // Last record must be sorted
		{
			char* stringLocation  = &memoryBlock[(i + 0) * memBlockSize + stringOffset]; // Point into the buffer where the text is
			char* stringLocation2 = &memoryBlock[(i + 1) * memBlockSize + stringOffset]; // +1

			if (String_isLowerAlphabetically (stringLocation, stringLocation2) )
			{
				char* block1 = &memoryBlock[(i + 0) * memBlockSize];
				char* block2 = &memoryBlock[(i + 1) * memBlockSize];

				memcpy (tmpBuf, block1, memBlockSize);
				memcpy (block1, block2, memBlockSize);
				memcpy (block2, tmpBuf, memBlockSize);
				didSwap = anySwap = True;
			}
		}
        limit--;
    }

	tmpBuf = Memory_free (tmpBuf);
	return anySwap; // If we touched anything, we return True otherwise we didn't change a thing
}
