//**********************************************************************************************************\
//
//	strings.h:	String functions, etc.
//
//**********************************************************************************************************/


// String functions
#define StringMatch(s1, s2)						!strcmp(s1, s2)
#define StringMatchCaseless(s1, s2)				!strcasecmp(s1, s2)
#define StringMatchNCaseless(s1, s2, s3)		!strncasecmp(s1, s2, s3)

#define StringNOTMatch(s1, s2)					(strcmp(s1, s2) !=0 )
#define StringNOTMatchCaseless(s1, s2)			(strcasecmp(s1, s2) !=0 )

#define StringStartsWith(bigstr, lilstr)		!strncmp(bigstr, lilstr, strlen(lilstr))
#define StringStartsWithCaseLess(bigstr, lilstr)!strncasecmp(bigstr, lilstr, strlen(lilstr))

#define StringLCopy(dest, source)				strlcpy(dest, source, sizeof(dest))
#define StringLCat(dest, stringToAppend)		strlcat(dest, stringToAppend, sizeof(dest))
#define StringInStr(bigString, findWhat)		(strstr(bigString, findWhat) != NULL)

#define String_isHigherAlphabetically(s1, s2)	(strcmp (s1, s2) < 0)
#define String_isLowerAlphabetically(s1, s2)	(strcmp (s1, s2) > 0)

fbool	StringEndsWith							(const char* bigString, const char* suffix);

void    String_Edit_SlashesForward_Like_Unix	(char *WindowsStylePath);
void    String_Edit_StripExtension				(char* myEditString);
char*   String_Edit_Append_To_Name				(char* filename, const char* appendToName);
void	String_Edit_ChangeExtension				(char* myEditString, const char* newExtension);
void	String_Edit_To_Parent_Path				(char* myPath);

char*   String_SkipPath							(const char* pathName);
fbool	String_isPathTopMost					(const char* pathName);

#define String_Path(buffer, formatText, path, filename) String_Buffer_Format (buffer, sizeof(buffer), formatText, path, filename)
char*	String_Buffer_Format					(char* buffer, size_t bufferSize, const char* formatText, const char* path, const char* filename);


